diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/class-wp-xmlrpc-server.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-wp-xmlrpc-server.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/class-wp-xmlrpc-server.php	2012-10-29 12:35:30.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-wp-xmlrpc-server.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 3381,3462 ****
  	}
  
  	/**
! 	 * Retrieve blog_filename content.
  	 *
  	 * @since 1.5.0
! 	 *
! 	 * @param array $args Method parameters.
! 	 * @return string
  	 */
  	function blogger_getTemplate($args) {
! 
! 		$this->escape($args);
! 
! 		$blog_ID    = (int) $args[1];
! 		$username = $args[2];
! 		$password  = $args[3];
! 		$template   = $args[4]; /* could be 'main' or 'archiveIndex', but we don't use it */
! 
! 		if ( !$user = $this->login($username, $password) )
! 			return $this->error;
! 
! 		do_action('xmlrpc_call', 'blogger.getTemplate');
! 
! 		if ( !current_user_can('edit_themes') )
! 			return new IXR_Error(401, __('Sorry, this user cannot edit the template.'));
! 
! 		/* warning: here we make the assumption that the blog's URL is on the same server */
! 		$filename = get_option('home') . '/';
! 		$filename = preg_replace('#https?://.+?/#', $_SERVER['DOCUMENT_ROOT'].'/', $filename);
! 
! 		$f = fopen($filename, 'r');
! 		$content = fread($f, filesize($filename));
! 		fclose($f);
! 
! 		/* so it is actually editable with a windows/mac client */
! 		// FIXME: (or delete me) do we really want to cater to bad clients at the expense of good ones by BEEPing up their line breaks? commented. $content = str_replace("\n", "\r\n", $content);
! 
! 		return $content;
  	}
  
  	/**
! 	 * Updates the content of blog_filename.
  	 *
  	 * @since 1.5.0
! 	 *
! 	 * @param array $args Method parameters.
! 	 * @return bool True when done.
  	 */
  	function blogger_setTemplate($args) {
! 
! 		$this->escape($args);
! 
! 		$blog_ID    = (int) $args[1];
! 		$username = $args[2];
! 		$password  = $args[3];
! 		$content    = $args[4];
! 		$template   = $args[5]; /* could be 'main' or 'archiveIndex', but we don't use it */
! 
! 		if ( !$user = $this->login($username, $password) )
! 			return $this->error;
! 
! 		do_action('xmlrpc_call', 'blogger.setTemplate');
! 
! 		if ( !current_user_can('edit_themes') )
! 			return new IXR_Error(401, __('Sorry, this user cannot edit the template.'));
! 
! 		/* warning: here we make the assumption that the blog's URL is on the same server */
! 		$filename = get_option('home') . '/';
! 		$filename = preg_replace('#https?://.+?/#', $_SERVER['DOCUMENT_ROOT'].'/', $filename);
! 
! 		if ($f = fopen($filename, 'w+')) {
! 			fwrite($f, $content);
! 			fclose($f);
! 		} else {
! 			return new IXR_Error(500, __('Either the file is not writable, or something wrong happened. The file has not been updated.'));
! 		}
! 
! 		return true;
  	}
  
  	/**
--- 3822,3844 ----
  	}
  
  	/**
! 	 * Deprecated.
  	 *
  	 * @since 1.5.0
! 	 * @deprecated 3.5.0
  	 */
  	function blogger_getTemplate($args) {
! 		return new IXR_Error( 403, __('Sorry, that file cannot be edited.' ) );
  	}
  
  	/**
! 	 * Deprecated.
  	 *
  	 * @since 1.5.0
! 	 * @deprecated 3.5.0
  	 */
  	function blogger_setTemplate($args) {
! 		return new IXR_Error( 403, __('Sorry, that file cannot be edited.' ) );
  	}
  
  	/**
***************
*** 3483,3489 ****
  		do_action('xmlrpc_call', 'blogger.newPost');
  
  		$cap = ($publish) ? 'publish_posts' : 'edit_posts';
! 		if ( !current_user_can($cap) )
  			return new IXR_Error(401, __('Sorry, you are not allowed to post on this site.'));
  
  		$post_status = ($publish) ? 'publish' : 'draft';
--- 3865,3871 ----
  		do_action('xmlrpc_call', 'blogger.newPost');
  
  		$cap = ($publish) ? 'publish_posts' : 'edit_posts';
! 		if ( ! current_user_can( get_post_type_object( 'post' )->cap->create_posts ) || !current_user_can($cap) )
  			return new IXR_Error(401, __('Sorry, you are not allowed to post on this site.'));
  
  		$post_status = ($publish) ? 'publish' : 'draft';
***************
*** 3536,3542 ****
  
  		do_action('xmlrpc_call', 'blogger.editPost');
  
! 		$actual_post = wp_get_single_post($post_ID,ARRAY_A);
  
  		if ( !$actual_post || $actual_post['post_type'] != 'post' )
  			return new IXR_Error(404, __('Sorry, no such post.'));
--- 3918,3924 ----
  
  		do_action('xmlrpc_call', 'blogger.editPost');
  
! 		$actual_post = get_post($post_ID,ARRAY_A);
  
  		if ( !$actual_post || $actual_post['post_type'] != 'post' )
  			return new IXR_Error(404, __('Sorry, no such post.'));
***************
*** 3590,3596 ****
  
  		do_action('xmlrpc_call', 'blogger.deletePost');
  
! 		$actual_post = wp_get_single_post($post_ID,ARRAY_A);
  
  		if ( !$actual_post || $actual_post['post_type'] != 'post' )
  			return new IXR_Error(404, __('Sorry, no such post.'));
--- 3972,3978 ----
  
  		do_action('xmlrpc_call', 'blogger.deletePost');
  
! 		$actual_post = get_post($post_ID,ARRAY_A);
  
  		if ( !$actual_post || $actual_post['post_type'] != 'post' )
  			return new IXR_Error(404, __('Sorry, no such post.'));
***************
*** 3698,3703 ****
--- 4080,4087 ----
  			$post_type = 'post';
  		}
  
+ 		if ( ! current_user_can( get_post_type_object( $post_type )->cap->create_posts ) )
+ 			return new IXR_Error( 401, __( 'Sorry, you are not allowed to publish posts on this site.' ) );
  		if ( !current_user_can( $cap ) )
  			return new IXR_Error( 401, $error_message );
  
***************
*** 3730,3747 ****
  		$post_author = $user->ID;
  
  		// If an author id was provided then use it instead.
! 		if ( isset($content_struct['wp_author_id']) && ($user->ID != $content_struct['wp_author_id']) ) {
  			switch ( $post_type ) {
  				case "post":
! 					if ( !current_user_can('edit_others_posts') )
! 						return(new IXR_Error(401, __('You are not allowed to post as this user')));
  					break;
  				case "page":
! 					if ( !current_user_can('edit_others_pages') )
! 						return(new IXR_Error(401, __('You are not allowed to create pages as this user')));
  					break;
  				default:
! 					return(new IXR_Error(401, __('Invalid post type')));
  					break;
  			}
  			$author = get_userdata( $content_struct['wp_author_id'] );
--- 4114,4131 ----
  		$post_author = $user->ID;
  
  		// If an author id was provided then use it instead.
! 		if ( isset( $content_struct['wp_author_id'] ) && ( $user->ID != $content_struct['wp_author_id'] ) ) {
  			switch ( $post_type ) {
  				case "post":
! 					if ( !current_user_can( 'edit_others_posts' ) )
! 						return( new IXR_Error( 401, __( 'You are not allowed to create posts as this user.' ) ) );
  					break;
  				case "page":
! 					if ( !current_user_can( 'edit_others_pages' ) )
! 						return( new IXR_Error( 401, __( 'You are not allowed to create pages as this user.' ) ) );
  					break;
  				default:
! 					return( new IXR_Error( 401, __( 'Invalid post type' ) ) );
  					break;
  			}
  			$author = get_userdata( $content_struct['wp_author_id'] );
***************
*** 3902,3908 ****
  		// Handle post formats if assigned, value is validated earlier
  		// in this function
  		if ( isset( $content_struct['wp_post_format'] ) )
! 			wp_set_post_terms( $post_ID, array( 'post-format-' . $content_struct['wp_post_format'] ), 'post_format' );
  
  		$post_ID = wp_insert_post( $postdata, true );
  		if ( is_wp_error( $post_ID ) )
--- 4286,4292 ----
  		// Handle post formats if assigned, value is validated earlier
  		// in this function
  		if ( isset( $content_struct['wp_post_format'] ) )
! 			set_post_format( $post_ID, $content_struct['wp_post_format'] );
  
  		$post_ID = wp_insert_post( $postdata, true );
  		if ( is_wp_error( $post_ID ) )
***************
*** 3980,3986 ****
  
  		do_action('xmlrpc_call', 'metaWeblog.editPost');
  
! 		$postdata = wp_get_single_post( $post_ID, ARRAY_A );
  
  		// If there is no post data for the give post id, stop
  		// now and return an error. Other wise a new post will be
--- 4364,4370 ----
  
  		do_action('xmlrpc_call', 'metaWeblog.editPost');
  
! 		$postdata = get_post( $post_ID, ARRAY_A );
  
  		// If there is no post data for the give post id, stop
  		// now and return an error. Other wise a new post will be
***************
*** 4219,4225 ****
  		// Handle post formats if assigned, validation is handled
  		// earlier in this function
  		if ( isset( $content_struct['wp_post_format'] ) )
! 			wp_set_post_terms( $post_ID, array( 'post-format-' . $content_struct['wp_post_format'] ), 'post_format' );
  
  		do_action( 'xmlrpc_call_success_mw_editPost', $post_ID, $args );
  
--- 4603,4609 ----
  		// Handle post formats if assigned, validation is handled
  		// earlier in this function
  		if ( isset( $content_struct['wp_post_format'] ) )
! 			set_post_format( $post_ID, $content_struct['wp_post_format'] );
  
  		do_action( 'xmlrpc_call_success_mw_editPost', $post_ID, $args );
  
***************
*** 4245,4251 ****
  		if ( !$user = $this->login($username, $password) )
  			return $this->error;
  
! 		$postdata = wp_get_single_post($post_ID, ARRAY_A);
  		if ( ! $postdata )
  			return new IXR_Error( 404, __( 'Invalid post ID.' ) );
  
--- 4629,4635 ----
  		if ( !$user = $this->login($username, $password) )
  			return $this->error;
  
! 		$postdata = get_post($post_ID, ARRAY_A);
  		if ( ! $postdata )
  			return new IXR_Error( 404, __( 'Invalid post ID.' ) );
  
***************
*** 4380,4385 ****
--- 4764,4770 ----
  		if ( !$posts_list )
  			return array();
  
+ 		$struct = array();
  		foreach ($posts_list as $entry) {
  			if ( !current_user_can( 'edit_post', $entry['ID'] ) )
  				continue;
***************
*** 4568,4575 ****
  			return new IXR_Error(500, $errorString);
  		}
  		// Construct the attachment array
- 		// attach to post_id 0
  		$post_id = 0;
  		$attachment = array(
  			'post_title' => $name,
  			'post_content' => '',
--- 4953,4965 ----
  			return new IXR_Error(500, $errorString);
  		}
  		// Construct the attachment array
  		$post_id = 0;
+ 		if ( ! empty( $data['post_id'] ) ) {
+ 			$post_id = (int) $data['post_id'];
+ 
+ 			if ( ! current_user_can( 'edit_post', $post_id ) )
+ 				return new IXR_Error( 401, __( 'Sorry, you cannot edit this post.' ) );
+ 		}
  		$attachment = array(
  			'post_title' => $name,
  			'post_content' => '',
***************
*** 4767,4772 ****
--- 5157,5163 ----
  		if ( !current_user_can('edit_post', $post_ID) )
  			return new IXR_Error(401, __('Sorry, you cannot edit this post.'));
  
+ 		$catids = array();
  		foreach ( $categories as $cat ) {
  			$catids[] = $cat['categoryId'];
  		}
***************
*** 4824,4830 ****
  
  		do_action('xmlrpc_call', 'mt.getTrackbackPings');
  
! 		$actual_post = wp_get_single_post($post_ID, ARRAY_A);
  
  		if ( !$actual_post )
  			return new IXR_Error(404, __('Sorry, no such post.'));
--- 5215,5221 ----
  
  		do_action('xmlrpc_call', 'mt.getTrackbackPings');
  
! 		$actual_post = get_post($post_ID, ARRAY_A);
  
  		if ( !$actual_post )
  			return new IXR_Error(404, __('Sorry, no such post.'));
***************
*** 4871,4877 ****
  
  		do_action('xmlrpc_call', 'mt.publishPost');
  
! 		$postdata = wp_get_single_post($post_ID, ARRAY_A);
  		if ( ! $postdata )
  			return new IXR_Error( 404, __( 'Invalid post ID.' ) );
  
--- 5262,5268 ----
  
  		do_action('xmlrpc_call', 'mt.publishPost');
  
! 		$postdata = get_post($post_ID, ARRAY_A);
  		if ( ! $postdata )
  			return new IXR_Error( 404, __( 'Invalid post ID.' ) );
  
***************
*** 4934,4940 ****
  			$blah = explode('/', $match[0]);
  			$post_ID = (int) $blah[1];
  			$way = 'from the path';
! 		} elseif ( preg_match('#p=[0-9]{1,}#', $urltest['query'], $match) ) {
  			// the querystring defines the post_ID (?p=XXXX)
  			$blah = explode('=', $match[0]);
  			$post_ID = (int) $blah[1];
--- 5325,5331 ----
  			$blah = explode('/', $match[0]);
  			$post_ID = (int) $blah[1];
  			$way = 'from the path';
! 		} elseif ( isset( $urltest['query'] ) && preg_match('#p=[0-9]{1,}#', $urltest['query'], $match) ) {
  			// the querystring defines the post_ID (?p=XXXX)
  			$blah = explode('=', $match[0]);
  			$post_ID = (int) $blah[1];
***************
*** 4994,5000 ****
  		// Work around bug in strip_tags():
  		$linea = str_replace('<!DOC', '<DOC', $linea);
  		$linea = preg_replace( '/[\s\r\n\t]+/', ' ', $linea ); // normalize spaces
! 		$linea = preg_replace( "/ <(h1|h2|h3|h4|h5|h6|p|th|td|li|dt|dd|pre|caption|input|textarea|button|body)[^>]*>/", "\n\n", $linea );
  
  		preg_match('|<title>([^<]*?)</title>|is', $linea, $matchtitle);
  		$title = $matchtitle[1];
--- 5385,5391 ----
  		// Work around bug in strip_tags():
  		$linea = str_replace('<!DOC', '<DOC', $linea);
  		$linea = preg_replace( '/[\s\r\n\t]+/', ' ', $linea ); // normalize spaces
! 		$linea = preg_replace( "/<\/*(h1|h2|h3|h4|h5|h6|p|th|td|li|dt|dd|pre|caption|input|textarea|button|body)[^>]*>/", "\n\n", $linea );
  
  		preg_match('|<title>([^<]*?)</title>|is', $linea, $matchtitle);
  		$title = $matchtitle[1];
***************
*** 5085,5091 ****
  	  		return new IXR_Error(33, __('The specified target URL cannot be used as a target. It either doesn&#8217;t exist, or it is not a pingback-enabled resource.'));
  		}
  
! 		$actual_post = wp_get_single_post($post_ID, ARRAY_A);
  
  		if ( !$actual_post ) {
  			// No such post = resource not found
--- 5476,5482 ----
  	  		return new IXR_Error(33, __('The specified target URL cannot be used as a target. It either doesn&#8217;t exist, or it is not a pingback-enabled resource.'));
  		}
  
! 		$actual_post = get_post($post_ID, ARRAY_A);
  
  		if ( !$actual_post ) {
  			// No such post = resource not found
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/comment.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/comment.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/comment.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/comment.php	2012-12-17 16:18:40.000000000 -0600
***************
*** 127,133 ****
   * @param string $output Optional. OBJECT or ARRAY_A or ARRAY_N constants.
   * @return object|array|null Depends on $output value.
   */
! function &get_comment(&$comment, $output = OBJECT) {
  	global $wpdb;
  	$null = null;
  
--- 127,133 ----
   * @param string $output Optional. OBJECT or ARRAY_A or ARRAY_N constants.
   * @return object|array|null Depends on $output value.
   */
! function get_comment(&$comment, $output = OBJECT) {
  	global $wpdb;
  	$null = null;
  
***************
*** 190,195 ****
--- 190,203 ----
   * @since 3.1.0
   */
  class WP_Comment_Query {
+ 	/**
+ 	 * Metadata query container
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 * @var object WP_Meta_Query
+ 	 */
+ 	var $meta_query = false;
  
  	/**
  	 * Execute the query
***************
*** 222,246 ****
  			'type' => '',
  			'user_id' => '',
  			'search' => '',
! 			'count' => false
  		);
  
  		$this->query_vars = wp_parse_args( $query_vars, $defaults );
  		do_action_ref_array( 'pre_get_comments', array( &$this ) );
  		extract( $this->query_vars, EXTR_SKIP );
  
  		// $args can be whatever, only use the args defined in defaults to compute the key
  		$key = md5( serialize( compact(array_keys($defaults)) )  );
! 		$last_changed = wp_cache_get('last_changed', 'comment');
! 		if ( !$last_changed ) {
! 			$last_changed = time();
! 			wp_cache_set('last_changed', $last_changed, 'comment');
! 		}
  		$cache_key = "get_comments:$key:$last_changed";
  
! 		if ( $cache = wp_cache_get( $cache_key, 'comment' ) ) {
  			return $cache;
- 		}
  
  		$post_id = absint($post_id);
  
--- 230,261 ----
  			'type' => '',
  			'user_id' => '',
  			'search' => '',
! 			'count' => false,
! 			'meta_key' => '',
! 			'meta_value' => '',
! 			'meta_query' => '',
  		);
  
+ 		$groupby = '';
+ 
  		$this->query_vars = wp_parse_args( $query_vars, $defaults );
+ 
+ 		// Parse meta query
+ 		$this->meta_query = new WP_Meta_Query();
+ 		$this->meta_query->parse_query_vars( $this->query_vars );
+ 
  		do_action_ref_array( 'pre_get_comments', array( &$this ) );
  		extract( $this->query_vars, EXTR_SKIP );
  
  		// $args can be whatever, only use the args defined in defaults to compute the key
  		$key = md5( serialize( compact(array_keys($defaults)) )  );
! 		$last_changed = wp_cache_get( 'last_changed', 'comment' );
! 		if ( ! $last_changed )
! 			$last_changed = wp_cache_set( 'last_changed', 1, 'comment' );
  		$cache_key = "get_comments:$key:$last_changed";
  
! 		if ( $cache = wp_cache_get( $cache_key, 'comment' ) )
  			return $cache;
  
  		$post_id = absint($post_id);
  
***************
*** 248,257 ****
  			$approved = "comment_approved = '0'";
  		elseif ( 'approve' == $status )
  			$approved = "comment_approved = '1'";
! 		elseif ( 'spam' == $status )
! 			$approved = "comment_approved = 'spam'";
! 		elseif ( 'trash' == $status )
! 			$approved = "comment_approved = 'trash'";
  		else
  			$approved = "( comment_approved = '0' OR comment_approved = '1' )";
  
--- 263,270 ----
  			$approved = "comment_approved = '0'";
  		elseif ( 'approve' == $status )
  			$approved = "comment_approved = '1'";
! 		elseif ( ! empty( $status ) && 'all' != $status )
! 			$approved = $wpdb->prepare( "comment_approved = %s", $status );
  		else
  			$approved = "( comment_approved = '0' OR comment_approved = '1' )";
  
***************
*** 259,284 ****
  
  		if ( ! empty( $orderby ) ) {
  			$ordersby = is_array($orderby) ? $orderby : preg_split('/[,\s]/', $orderby);
! 			$ordersby = array_intersect(
! 				$ordersby,
! 				array(
! 					'comment_agent',
! 					'comment_approved',
! 					'comment_author',
! 					'comment_author_email',
! 					'comment_author_IP',
! 					'comment_author_url',
! 					'comment_content',
! 					'comment_date',
! 					'comment_date_gmt',
! 					'comment_ID',
! 					'comment_karma',
! 					'comment_parent',
! 					'comment_post_ID',
! 					'comment_type',
! 					'user_id',
! 				)
  			);
  			$orderby = empty( $ordersby ) ? 'comment_date_gmt' : implode(', ', $ordersby);
  		} else {
  			$orderby = 'comment_date_gmt';
--- 272,307 ----
  
  		if ( ! empty( $orderby ) ) {
  			$ordersby = is_array($orderby) ? $orderby : preg_split('/[,\s]/', $orderby);
! 			$allowed_keys = array(
! 				'comment_agent',
! 				'comment_approved',
! 				'comment_author',
! 				'comment_author_email',
! 				'comment_author_IP',
! 				'comment_author_url',
! 				'comment_content',
! 				'comment_date',
! 				'comment_date_gmt',
! 				'comment_ID',
! 				'comment_karma',
! 				'comment_parent',
! 				'comment_post_ID',
! 				'comment_type',
! 				'user_id',
  			);
+ 			if ( ! empty( $this->query_vars['meta_key'] ) ) {
+ 				$allowed_keys[] = $q['meta_key'];
+ 				$allowed_keys[] = 'meta_value';
+ 				$allowed_keys[] = 'meta_value_num';
+ 			}
+ 			$ordersby = array_intersect( $ordersby, $allowed_keys );
+ 			foreach ( $ordersby as $key => $value ) {
+ 				if ( $value == $q['meta_key'] || $value == 'meta_value' ) {
+ 					$ordersby[ $key ] = "$wpdb->commentmeta.meta_value";
+ 				} elseif ( $value == 'meta_value_num' ) {
+ 					$ordersby[ $key ] = "$wpdb->commentmeta.meta_value+0";
+ 				}
+ 			}
  			$orderby = empty( $ordersby ) ? 'comment_date_gmt' : implode(', ', $ordersby);
  		} else {
  			$orderby = 'comment_date_gmt';
***************
*** 331,342 ****
  				$where .= $wpdb->prepare( " AND {$wpdb->posts}.{$field_name} = %s", $field_value );
  		}
  
! 		$pieces = array( 'fields', 'join', 'where', 'orderby', 'order', 'limits' );
  		$clauses = apply_filters_ref_array( 'comments_clauses', array( compact( $pieces ), &$this ) );
  		foreach ( $pieces as $piece )
  			$$piece = isset( $clauses[ $piece ] ) ? $clauses[ $piece ] : '';
  
! 		$query = "SELECT $fields FROM $wpdb->comments $join WHERE $where ORDER BY $orderby $order $limits";
  
  		if ( $count )
  			return $wpdb->get_var( $query );
--- 354,375 ----
  				$where .= $wpdb->prepare( " AND {$wpdb->posts}.{$field_name} = %s", $field_value );
  		}
  
! 		if ( ! empty( $this->meta_query->queries ) ) {
! 			$clauses = $this->meta_query->get_sql( 'comment', $wpdb->comments, 'comment_ID', $this );
! 			$join .= $clauses['join'];
! 			$where .= $clauses['where'];
! 			$groupby = "{$wpdb->comments}.comment_ID";
! 		}
! 
! 		$pieces = array( 'fields', 'join', 'where', 'orderby', 'order', 'limits', 'groupby' );
  		$clauses = apply_filters_ref_array( 'comments_clauses', array( compact( $pieces ), &$this ) );
  		foreach ( $pieces as $piece )
  			$$piece = isset( $clauses[ $piece ] ) ? $clauses[ $piece ] : '';
  
! 		if ( $groupby )
! 			$groupby = 'GROUP BY ' . $groupby;
! 
! 		$query = "SELECT $fields FROM $wpdb->comments $join WHERE $where $groupby ORDER BY $orderby $order $limits";
  
  		if ( $count )
  			return $wpdb->get_var( $query );
***************
*** 399,412 ****
   *
   * @since 1.5.0
   * @uses $wpdb
-  * @global array $cache_lastcommentmodified
   *
   * @param string $timezone Which timezone to use in reference to 'gmt', 'blog',
   *		or 'server' locations.
   * @return string Last comment modified date.
   */
  function get_lastcommentmodified($timezone = 'server') {
! 	global $cache_lastcommentmodified, $wpdb;
  
  	if ( isset($cache_lastcommentmodified[$timezone]) )
  		return $cache_lastcommentmodified[$timezone];
--- 432,445 ----
   *
   * @since 1.5.0
   * @uses $wpdb
   *
   * @param string $timezone Which timezone to use in reference to 'gmt', 'blog',
   *		or 'server' locations.
   * @return string Last comment modified date.
   */
  function get_lastcommentmodified($timezone = 'server') {
! 	global $wpdb;
! 	static $cache_lastcommentmodified = array();
  
  	if ( isset($cache_lastcommentmodified[$timezone]) )
  		return $cache_lastcommentmodified[$timezone];
***************
*** 636,642 ****
  
  	// Simple duplicate check
  	// expected_slashed ($comment_post_ID, $comment_author, $comment_author_email, $comment_content)
! 	$dupe = "SELECT comment_ID FROM $wpdb->comments WHERE comment_post_ID = '$comment_post_ID' AND comment_approved != 'trash' AND ( comment_author = '$comment_author' ";
  	if ( $comment_author_email )
  		$dupe .= "OR comment_author_email = '$comment_author_email' ";
  	$dupe .= ") AND comment_content = '$comment_content' LIMIT 1";
--- 669,675 ----
  
  	// Simple duplicate check
  	// expected_slashed ($comment_post_ID, $comment_author, $comment_author_email, $comment_content)
! 	$dupe = "SELECT comment_ID FROM $wpdb->comments WHERE comment_post_ID = '$comment_post_ID' AND comment_parent = '$comment_parent' AND comment_approved != 'trash' AND ( comment_author = '$comment_author' ";
  	if ( $comment_author_email )
  		$dupe .= "OR comment_author_email = '$comment_author_email' ";
  	$dupe .= ") AND comment_content = '$comment_content' LIMIT 1";
***************
*** 650,662 ****
  
  	do_action( 'check_comment_flood', $comment_author_IP, $comment_author_email, $comment_date_gmt );
  
! 	if ( isset($user_id) && $user_id) {
! 		$userdata = get_userdata($user_id);
! 		$user = new WP_User($user_id);
  		$post_author = $wpdb->get_var($wpdb->prepare("SELECT post_author FROM $wpdb->posts WHERE ID = %d LIMIT 1", $comment_post_ID));
  	}
  
! 	if ( isset($userdata) && ( $user_id == $post_author || $user->has_cap('moderate_comments') ) ) {
  		// The author and the admins get respect.
  		$approved = 1;
  	 } else {
--- 683,694 ----
  
  	do_action( 'check_comment_flood', $comment_author_IP, $comment_author_email, $comment_date_gmt );
  
! 	if ( ! empty( $user_id ) ) {
! 		$user = get_userdata( $user_id );
  		$post_author = $wpdb->get_var($wpdb->prepare("SELECT post_author FROM $wpdb->posts WHERE ID = %d LIMIT 1", $comment_post_ID));
  	}
  
! 	if ( isset( $user ) && ( $user_id == $post_author || $user->has_cap( 'moderate_comments' ) ) ) {
  		// The author and the admins get respect.
  		$approved = 1;
  	 } else {
***************
*** 694,700 ****
  	global $wpdb;
  	if ( current_user_can( 'manage_options' ) )
  		return; // don't throttle admins
! 	$hour_ago = gmdate( 'Y-m-d H:i:s', time() - 3600 );
  	if ( $lasttime = $wpdb->get_var( $wpdb->prepare( "SELECT `comment_date_gmt` FROM `$wpdb->comments` WHERE `comment_date_gmt` >= %s AND ( `comment_author_IP` = %s OR `comment_author_email` = %s ) ORDER BY `comment_date_gmt` DESC LIMIT 1", $hour_ago, $ip, $email ) ) ) {
  		$time_lastcomment = mysql2date('U', $lasttime, false);
  		$time_newcomment  = mysql2date('U', $date, false);
--- 726,732 ----
  	global $wpdb;
  	if ( current_user_can( 'manage_options' ) )
  		return; // don't throttle admins
! 	$hour_ago = gmdate( 'Y-m-d H:i:s', time() - HOUR_IN_SECONDS );
  	if ( $lasttime = $wpdb->get_var( $wpdb->prepare( "SELECT `comment_date_gmt` FROM `$wpdb->comments` WHERE `comment_date_gmt` >= %s AND ( `comment_author_IP` = %s OR `comment_author_email` = %s ) ORDER BY `comment_date_gmt` DESC LIMIT 1", $hour_ago, $ip, $email ) ) ) {
  		$time_lastcomment = mysql2date('U', $lasttime, false);
  		$time_newcomment  = mysql2date('U', $date, false);
***************
*** 718,724 ****
   * @param array $comments Array of comments
   * @return array Array of comments keyed by comment_type.
   */
! function &separate_comments(&$comments) {
  	$comments_by_type = array('comment' => array(), 'trackback' => array(), 'pingback' => array(), 'pings' => array());
  	$count = count($comments);
  	for ( $i = 0; $i < $count; $i++ ) {
--- 750,756 ----
   * @param array $comments Array of comments
   * @return array Array of comments keyed by comment_type.
   */
! function separate_comments(&$comments) {
  	$comments_by_type = array('comment' => array(), 'trackback' => array(), 'pingback' => array(), 'pings' => array());
  	$count = count($comments);
  	for ( $i = 0; $i < $count; $i++ ) {
***************
*** 1258,1263 ****
--- 1290,1302 ----
  	$comment = get_comment($id);
  	do_action('wp_insert_comment', $id, $comment);
  
+ 	if ( function_exists( 'wp_cache_incr' ) ) {
+ 		wp_cache_incr( 'last_changed', 1, 'comment' );
+ 	} else {
+ 		$last_changed = wp_cache_get( 'last_changed', 'comment' );
+ 		wp_cache_set( 'last_changed', $last_changed + 1, 'comment' );
+ 	}
+ 
  	return $id;
  }
  
***************
*** 1366,1372 ****
  		if ( '0' == $commentdata['comment_approved'] )
  			wp_notify_moderator($comment_ID);
  
! 		$post = &get_post($commentdata['comment_post_ID']); // Don't notify if it's your own comment
  
  		if ( get_option('comments_notify') && $commentdata['comment_approved'] && ( ! isset( $commentdata['user_id'] ) || $post->post_author != $commentdata['user_id'] ) )
  			wp_notify_postauthor($comment_ID, isset( $commentdata['comment_type'] ) ? $commentdata['comment_type'] : '' );
--- 1405,1411 ----
  		if ( '0' == $commentdata['comment_approved'] )
  			wp_notify_moderator($comment_ID);
  
! 		$post = get_post($commentdata['comment_post_ID']); // Don't notify if it's your own comment
  
  		if ( get_option('comments_notify') && $commentdata['comment_approved'] && ( ! isset( $commentdata['user_id'] ) || $post->post_author != $commentdata['user_id'] ) )
  			wp_notify_postauthor($comment_ID, isset( $commentdata['comment_type'] ) ? $commentdata['comment_type'] : '' );
***************
*** 1479,1485 ****
  	else if ( 'approve' == $comment_approved )
  		$comment_approved = 1;
  
! 	$data = compact('comment_content', 'comment_author', 'comment_author_email', 'comment_approved', 'comment_karma', 'comment_author_url', 'comment_date', 'comment_date_gmt');
  	$rval = $wpdb->update( $wpdb->comments, $data, compact( 'comment_ID' ) );
  
  	clean_comment_cache($comment_ID);
--- 1518,1524 ----
  	else if ( 'approve' == $comment_approved )
  		$comment_approved = 1;
  
! 	$data = compact( 'comment_content', 'comment_author', 'comment_author_email', 'comment_approved', 'comment_karma', 'comment_author_url', 'comment_date', 'comment_date_gmt', 'comment_parent' );
  	$rval = $wpdb->update( $wpdb->comments, $data, compact( 'comment_ID' ) );
  
  	clean_comment_cache($comment_ID);
***************
*** 1704,1710 ****
  function do_trackbacks($post_id) {
  	global $wpdb;
  
! 	$post = $wpdb->get_row( $wpdb->prepare("SELECT * FROM $wpdb->posts WHERE ID = %d", $post_id) );
  	$to_ping = get_to_ping($post_id);
  	$pinged  = get_pung($post_id);
  	if ( empty($to_ping) ) {
--- 1743,1749 ----
  function do_trackbacks($post_id) {
  	global $wpdb;
  
! 	$post = get_post( $post_id );
  	$to_ping = get_to_ping($post_id);
  	$pinged  = get_pung($post_id);
  	if ( empty($to_ping) ) {
***************
*** 1929,1935 ****
  	foreach ( (array) $ids as $id )
  		wp_cache_delete($id, 'comment');
  
! 	wp_cache_set('last_changed', time(), 'comment');
  }
  
  /**
--- 1968,1979 ----
  	foreach ( (array) $ids as $id )
  		wp_cache_delete($id, 'comment');
  
! 	if ( function_exists( 'wp_cache_incr' ) ) {
! 		wp_cache_incr( 'last_changed', 1, 'comment' );
! 	} else {
! 		$last_changed = wp_cache_get( 'last_changed', 'comment' );
! 		wp_cache_set( 'last_changed', $last_changed + 1, 'comment' );
! 	}
  }
  
  /**
***************
*** 1976,1982 ****
  	if ( ! $days_old )
  		return $posts;
  
! 	if ( time() - strtotime( $posts[0]->post_date_gmt ) > ( $days_old * 24 * 60 * 60 ) ) {
  		$posts[0]->comment_status = 'closed';
  		$posts[0]->ping_status = 'closed';
  	}
--- 2020,2026 ----
  	if ( ! $days_old )
  		return $posts;
  
! 	if ( time() - strtotime( $posts[0]->post_date_gmt ) > ( $days_old * DAY_IN_SECONDS ) ) {
  		$posts[0]->comment_status = 'closed';
  		$posts[0]->ping_status = 'closed';
  	}
***************
*** 2011,2017 ****
  	if ( ! in_array( $post->post_type, $post_types ) )
  		return $open;
  
! 	if ( time() - strtotime( $post->post_date_gmt ) > ( $days_old * 24 * 60 * 60 ) )
  		return false;
  
  	return $open;
--- 2055,2061 ----
  	if ( ! in_array( $post->post_type, $post_types ) )
  		return $open;
  
! 	if ( time() - strtotime( $post->post_date_gmt ) > ( $days_old * DAY_IN_SECONDS ) )
  		return false;
  
  	return $open;
